import gdk.*;
import gtk.*;
import java.util.*;

/**
   A transcription of the testgtk.c example in Java. 
   
   Not the very best example of good object-oriented Java programming,
   but well, that's not the aim. :-)
   
   @author Ol. Gutknecht, Aug 1999

 */

public class TestGTK
{
    // members
    GtkCList clist = null;
    GtkLabel label = null;
    GtkToolbar toolbar = null;
    GtkList list = null;
    int listItemCounter = 0;
    boolean labelSet = false;
    GtkEntry entry = null;
    GtkCheckButton editable = null;
    GtkCheckButton visible = null;
    GtkCheckButton sensitive = null;

    public boolean delete_event(int dummy) {
        Gtk.mainQuit();
        return true;
    };   
    
    public void destroy() {
        Gtk.mainQuit();
    };   

    public void clicked() {
        Gtk.mainQuit(); 
    };
    
    public void do_exit() {
        Gtk.mainQuit();
    };
    

    ////////////////////////////////////////////////////////
    // Button Box
    ////////////////////////////////////////////////////////
    GtkFrame create_bb(boolean horizontal, String title, int spacing, 
                       int child_w, int child_h, GtkButtonBoxStyle layout) {
        GtkButtonBox box;
        
        GtkFrame frame = new GtkFrame(title);
        if (horizontal)
            box = new GtkHButtonBox ();
        else
            box = new GtkVButtonBox ();
        
        box.setBorderWidth(5);
        frame.add(box);
        box.setLayout(layout);
        box.setSpacing(spacing);
        box.setChildSize(child_w, child_h);
        
        GtkButton button;
        button = new GtkButton("start");
        box.add(button);
        button = new GtkButton("cancel");
        box.add(button);
        button = new GtkButton("help");
        box.add(button);
        
        return frame;
    }
    

    public void createButtonBox() {
        GtkWindow win = new GtkWindow();
        win.setTitle("Radio Buttons");

        GtkVBox mainvbox = new GtkVBox ();
        win.add(mainvbox);
        mainvbox.setBorderWidth(10);
        
        GtkFrame frame_horiz = new GtkFrame("Horizontal Button Boxes");
        mainvbox.packStart(frame_horiz, true, true, 10);
        
        GtkVBox vbox = new GtkVBox ();
        vbox.setBorderWidth(10);
        frame_horiz.add(vbox);

        vbox.packStart(create_bb(true, "Spread", 40, 85, 20, 
                                 GtkButtonBoxStyle.GTK_BUTTONBOX_SPREAD), 
                       true, true, 0);
        vbox.packStart(create_bb(true, "Edge", 40, 85, 20, 
                                 GtkButtonBoxStyle.GTK_BUTTONBOX_EDGE), 
                       true, true, 5);
        vbox.packStart(create_bb(true, "Start", 40, 85, 20, 
                                 GtkButtonBoxStyle.GTK_BUTTONBOX_START), 
                       true, true, 5);
        vbox.packStart(create_bb(true, "End", 40, 85, 20, 
                                 GtkButtonBoxStyle.GTK_BUTTONBOX_END), 
                       true, true, 5);
        
        GtkFrame frame_vert = new GtkFrame("Vertical Button Boxes");
        mainvbox.packStart(frame_vert, true, true, 10);
        
        
        GtkHBox hbox = new GtkHBox ();
        hbox.setBorderWidth(10);
        frame_vert.add(hbox);
        
        hbox.packStart(create_bb(false, "Spread", 30, 85, 20, 
                                 GtkButtonBoxStyle.GTK_BUTTONBOX_SPREAD), 
                       true, true, 0);
        hbox.packStart(create_bb(false, "Edge", 30, 85, 20, 
                                 GtkButtonBoxStyle.GTK_BUTTONBOX_EDGE), 
                       true, true, 5);
        hbox.packStart(create_bb(false, "Start", 30, 85, 20, 
                                 GtkButtonBoxStyle.GTK_BUTTONBOX_START), 
                       true, true, 5);
        hbox.packStart(create_bb(false, "End", 30, 85, 20, 
                                 GtkButtonBoxStyle.GTK_BUTTONBOX_END), 
                       true, true, 5);

        GtkButton button = new GtkButton("close");
        button.signal_connect("clicked", "hide", win);
        mainvbox.packStartDefaults(button);
        //              button.set_flags(CAN_DEFAULT);
        // button.grabDefault();
        button.show();
        win.showAll();
    }
    
    ////////////////////////////////////////////////////////
    // Buttons
    ////////////////////////////////////////////////////////
    public void createButtons() {
        GtkWindow win = new GtkWindow(GtkWindowType.GTK_WINDOW_TOPLEVEL);
        
        win.setTitle("buttons");
        GtkVBox box1 = new GtkVBox(false, 0);
        win.add(box1);
        GtkTable table = new GtkTable(3, 3, false);
        table.setRowSpacings(5);
        table.setColSpacings(5);
        table.setBorderWidth(10);
        box1.packStartDefaults(table);
        
        GtkButton buttons[] = new GtkButton[9];
        for (int i=0; i<3; i++)
            for (int j=0; j<3; j++) {
                int n = i*3+j;
                buttons[n] = new GtkButton("button"+n);
                table.attachDefaults(buttons[n], i, i+1, j, j+1);
                // We don't have access to widget flags yet
            }
        for (int n=0; n<9; n++)
            buttons[n].signal_connect("clicked", "hide", buttons[(n+1)%9]);


        GtkHSeparator separator = new GtkHSeparator();
        box1.packStartDefaults(separator);
            
        GtkVBox box2 = new GtkVBox(true, 10);
        box2.setBorderWidth(10);
        box1.packStartDefaults(box2);
            
        GtkButton button = new GtkButton("close");
        button.signal_connect("clicked", "hide", win);
        //  button.connect("clicked", win.hide);
        box2.packStartDefaults(button);
        win.showAll();
    }

    ////////////////////////////////////////////////////////
    // Check Buttons
    ////////////////////////////////////////////////////////
    public void createCheckButtons() {
        GtkWindow win = new GtkWindow();
        win.setTitle("check buttons");
        
        GtkVBox box1 = new GtkVBox(false, 0);
        win.add(box1);

        GtkVBox box2 = new GtkVBox(false, 10);
        box2.setBorderWidth(10);
        box1.packStartDefaults(box2);

        for (int i = 1; i < 5; i++) {
            GtkCheckButton button = new GtkCheckButton("button" + i);
            box2.packStartDefaults(button);
        }

        GtkHSeparator separator = new GtkHSeparator();
        box1.packStart(separator, false, false, 0);

        GtkVBox box3 = new GtkVBox(false, 10);
        box3.setBorderWidth(10);
        box1.packStart(box3, false, false, 0);

        GtkButton button = new GtkButton("close");
        button.signal_connect("clicked", "hide", win);
        box3.packStartDefaults(button);

        win.showAll();
    }

    ////////////////////////////////////////////////////////
    // CList
    ////////////////////////////////////////////////////////
    public void createCList() {
        GtkWindow win = new GtkWindow();
        win.setTitle("clist");
        
        GtkVBox box1 = new GtkVBox(false, 0);
        win.add(box1);

        GtkHBox box2 = new GtkHBox(false, 10);
        box2.setBorderWidth(10);
        box1.packStart(box2, false, false, 0);

        GtkButton button = new GtkButton("Add 1,000 Rows");
        box2.packStartDefaults(button);
        button.signal_connect("clicked", "add1000Rows", this);

        button = new GtkButton("Add 10,000 Rows");
        box2.packStartDefaults(button);
        button.signal_connect("clicked", "add10000Rows", this);
        
        button = new GtkButton("Clear List");
        box2.packStartDefaults(button);
        button.signal_connect("clicked", "clearList", this);

        button = new GtkButton("Remove Row");
        box2.packStartDefaults(button);
        button.signal_connect("clicked", "removeRow", this);

        GtkHBox box3 = new GtkHBox(false, 10);
        box3.setBorderWidth(10);
        box1.packStart(box3, false, false, 0);

        button = new GtkButton("Show Title Buttons");
        box3.packStartDefaults(button);
        button.signal_connect("clicked", "showTitles", this);

        button = new GtkButton("Hide Title Buttons");
        box3.packStartDefaults(button);
        button.signal_connect("clicked", "hideTitles", this);

        GtkVBox box4 = new GtkVBox(false, 10);
        box4.setBorderWidth(10);
        box1.packStartDefaults(box4);

        String[] titles = { "Title 0", "Title 1", "Title 2", "Title 3",
                            "Title 4", "Title 5", "Title 6" };
        clist = new GtkCList(7, titles);
        clist.setColumnWidth(0, 100);
        for (int i = 1; i < 7; i++)
            clist.setColumnWidth(i, 80);
        clist.columnTitlesShow();
        clist.setRowHeight(20);
        clist.setSelectionMode(GtkSelectionMode.GTK_SELECTION_BROWSE);
        clist.setColumnJustification(1, GtkJustification.GTK_JUSTIFY_RIGHT);
        clist.setColumnJustification(2, GtkJustification.GTK_JUSTIFY_CENTER);

        GtkScrolledWindow swin = new GtkScrolledWindow(new GtkAdjustment(),
                                                       new GtkAdjustment());
        swin.setPolicy(GtkPolicyType.GTK_POLICY_AUTOMATIC, 
                       GtkPolicyType.GTK_POLICY_AUTOMATIC);
        box4.packStartDefaults(swin);
        
        swin.add(clist);
        
        GtkHSeparator sep = new GtkHSeparator();
        box1.packStart(sep, false, false, 0);

        GtkVBox box5 = new GtkVBox(false, 10);
        box5.setBorderWidth(10);
        box1.packStart(box5, false, false, 0);

        button = new GtkButton("close");
        button.signal_connect("clicked", "hide", win);
        box5.packStartDefaults(button);
        
        win.showAll();
    }

    public void addRow(int row) {
        String[] data = { "Row " + row, "Right", "Center", "Column 3",
                          "Column 4", "Column 5", "Column 6" };
        clist.append(data);
    }

    //
    // CList Callbacks
    //
    public void add1000Rows() {
        clist.freeze();
        for (int i = 0; i < 1000; i++)
            addRow(i);
        clist.thaw();
    }

    public void add10000Rows() {
        clist.freeze();
        for (int i = 0; i < 10000; i++) 
            addRow(i);
        clist.thaw();
    }

    public void clearList() {
        clist.clear();
    }

    public void removeRow() {
        System.out.println("Not implemented yet!");
    }

    public void showTitles() {
        clist.columnTitlesShow();
    }

    public void hideTitles() {
        clist.columnTitlesHide();
    }

    ////////////////////////////////////////////////////////
    // Color Selection
    ////////////////////////////////////////////////////////
    public void createColorSelection() {
        GtkColorSelectionDialog win = 
            new GtkColorSelectionDialog("color selection dialog");
        // currently this dialog doesn't display when I connect the
        // clicked signals of the buttons to the hide callback.
        //((GtkButton)win.getcancel_button()).
        //    signal_connect("clicked", "hide", win);
        //((GtkButton)win.getok_button()).
        //    signal_connect("clicked", "hide", win);
        win.show();
    }

    ////////////////////////////////////////////////////////
    // Dialog
    ////////////////////////////////////////////////////////
    public void createDialog() {
        GtkDialog win = new GtkDialog();
        win.setTitle("dialog");
        // there is a problem with the action_area 
        //GtkBox hbox = win.getaction_area();
        GtkHBox hbox = new GtkHBox(true, 10);
        GtkBox vbox = win.getvbox();

        label = new GtkLabel("");
        label.setPadding(10, 10);
        vbox.packStart(label);
        
        GtkButton button = new GtkButton("OK");
        button.signal_connect("clicked", "hide", win);
        hbox.packStart(button, false, true, 10);

        button = new GtkButton("Toggle");
        button.signal_connect("clicked", "toggleLabel", this);
        hbox.packStart(button, false, true, 10);
        vbox.packStart(hbox);
        win.showAll();
    }

    //
    // Dialog Callbacks
    //
    public void toggleLabel() {
        if (labelSet) {
            label.setText("");
            labelSet = false;
        }
        else {
            label.setText("Toggled");
            labelSet = true;
        }
    }

    ////////////////////////////////////////////////////////
    // Entry
    ////////////////////////////////////////////////////////
    public void createEntry() {
        GtkWindow win = new GtkWindow();
        win.setTitle("entry");
        
        GtkVBox box1 = new GtkVBox();
        win.add(box1);

        GtkVBox box2 = new GtkVBox(false, 10);
        box2.setBorderWidth(10);
        box1.packStart(box2);

        entry = new GtkEntry();
        entry.setText("hello world");
        entry.selectRegion(0, 5);
        box2.packStart(entry);

        Vector items = new Vector();
        items.addElement("item0");
        items.addElement("item1, item1");
        items.addElement("item2, item2, item2");
        items.addElement("item3, item3, item3, item3");
        items.addElement("item4, item4, item4, item4, item4");
        items.addElement("item5, item5, item5, item5, item5, item5");
        items.addElement("item6, item6, item6, item6, item6");
        items.addElement("item7, item7, item7, item7");
        items.addElement("item8, item8, item8");
        items.addElement("item9, item9");
        GtkCombo combo = new GtkCombo();
        // This method is causing core dump.  Need to investivate further.
        combo.setPopdownStrings(new GListString(items));
        box2.packStart(combo);
        
        
        editable = new GtkCheckButton("Editable");
        box2.packStart(editable, false, true, 0);
        editable.setActive(true);
        editable.signal_connect("toggled", "editableToggled", this);

        visible = new GtkCheckButton("Visible");
        box2.packStart(visible, false, true, 0);
        visible.setActive(true);
        visible.signal_connect("toggled", "visibleToggled", this);
        
        sensitive = new GtkCheckButton("Sensitive");
        box2.packStart(sensitive, false, true, 0);
        sensitive.setActive(true);
        sensitive.signal_connect("toggled", "sensitiveToggled", this);

        GtkHSeparator separator = new GtkHSeparator();
        box1.packStart(separator, false, true, 0);
        
        GtkVBox box3 = new GtkVBox(false, 10);
        box3.setBorderWidth(10);
        box1.packStart(box3, false, true, 0);

        GtkButton button = new GtkButton("close");
        button.signal_connect("clicked", "hide", win);
        box3.packStart(button);

        win.showAll();
    }

    //
    // Entry Callbacks
    //
    public void editableToggled() {
        entry.setEditable(editable.getActive());
    }

    public void visibleToggled() {
        entry.setVisibility(visible.getActive());
    }

    public void sensitiveToggled() {
        entry.setSensitive(sensitive.getActive());
    }

    ////////////////////////////////////////////////////////
    // File Selection
    ////////////////////////////////////////////////////////
    public void createFileSelection() {
        GtkFileSelection win = 
            new GtkFileSelection("file selection");
        // currently this dialog doesn't display when I connect the
        // clicked signals of the buttons to the hide callback.
        //((GtkButton)win.getcancel_button()).
        //    signal_connect("clicked", "hide", win);
        //((GtkButton)win.getok_button()).
        //    signal_connect("clicked", "hide", win);
        win.show();
    }

    ////////////////////////////////////////////////////////
    // Font Selection
    ////////////////////////////////////////////////////////
    public void createFontSelection() {
        GtkFontSelectionDialog win = 
            new GtkFontSelectionDialog("font selection");
        // currently this dialog doesn't display when I connect the
        // clicked signals of the buttons to the hide callback.
        //((GtkButton)win.getcancel_button()).
        //    signal_connect("clicked", "hide", win);
        //((GtkButton)win.getapply_button()).
        //    signal_connect("clicked", "hide", win);
        win.show();
        
    }

    ////////////////////////////////////////////////////////
    // Gamma Curve
    ////////////////////////////////////////////////////////
    public void createGammaCurve() {
        GtkWindow win = new GtkWindow();
        win.setTitle("gamma curve");
        win.setUsize(200, 200);

        GtkGammaCurve curve = new GtkGammaCurve();
        win.add(curve);
        curve.show();

        win.show();
    }

    ////////////////////////////////////////////////////////
    // Handle Box
    ////////////////////////////////////////////////////////
    public void createHandleBox() {
        GtkWindow win = new GtkWindow();
        win.setTitle("handle box");
        win.setPolicy(true, true, true);
        win.setBorderWidth(20);
        
        GtkVBox vbox = new GtkVBox(false, 0);
        win.add(vbox);

        GtkLabel label = new GtkLabel("Above");
        vbox.add(label);

        GtkHSeparator separator = new GtkHSeparator();
        vbox.add(separator);

        GtkHBox hbox = new GtkHBox(false, 10);
        vbox.add(hbox);

        separator = new GtkHSeparator();
        vbox.add(separator);
        separator.show();

        label = new GtkLabel("Below");
        vbox.add(label);

        GtkHandleBox handleBox = new GtkHandleBox();
        hbox.packStart(handleBox, false, false, 0);
        handleBox.show();

        toolbar = makeToolbar();
        handleBox.add(toolbar);

        win.showAll();
    }

    GtkToolbar makeToolbar() {
        GtkToolbar tb = new GtkToolbar(GtkOrientation.GTK_ORIENTATION_HORIZONTAL,
                                       GtkToolbarStyle.GTK_TOOLBAR_TEXT);
        
        GtkButton button = new GtkButton("Horizontal");
        tb.appendWidget(button, "Horizontal toolbar layout", null);
        button.signal_connect("clicked", "setToolbarHorizontal", this);
        
        button = new GtkButton("Vertical");
        tb.appendWidget(button, "Vertical toolbar layout", null);
        button.signal_connect("clicked", "setToolbarVertical", this);
        tb.appendSpace();
        
        button = new GtkButton("Small");
        tb.appendWidget(button, "Use small spaces", null);
        button.signal_connect("clicked", "setToolbarSmallSpace", this);

        button = new GtkButton("Big");
        tb.appendWidget(button, "Use big spaces", null);
        button.signal_connect("clicked", "setToolbarBigSpace", this);
        tb.appendSpace();

        button = new GtkButton("Enable");
        tb.appendWidget(button, "Enable tooltips", null);
        button.signal_connect("clicked", "setToolbarEnableTooltips", this);

        button = new GtkButton("Disable");
        tb.appendWidget(button, "Disable tooltips", null);
        button.signal_connect("clicked", "setToolbarDisableTooltips", this);
        tb.appendSpace();

        return tb;
    }

    //
    // Handle Box Events
    //
    public void setToolbarHorizontal() {
        toolbar.setOrientation(GtkOrientation.GTK_ORIENTATION_HORIZONTAL);
    }

    public void setToolbarVertical() {
        toolbar.setOrientation(GtkOrientation.GTK_ORIENTATION_VERTICAL);
    }

    public void setToolbarSmallSpace() {
        toolbar.setSpaceSize(5);
    }

    public void setToolbarBigSpace() {
        toolbar.setSpaceSize(10);
    }

    public void setToolbarEnableTooltips() {
        toolbar.setTooltips(true);
    }

    public void setToolbarDisableTooltips() {
        toolbar.setTooltips(false);
    }

    ////////////////////////////////////////////////////////
    // Labels
    ////////////////////////////////////////////////////////
    public void createLabels() {
        GtkWindow win = new GtkWindow();
        win.setTitle("labels");
        win.setBorderWidth(5);

        GtkVBox vbox1 = new GtkVBox(false, 5);
        GtkHBox hbox = new GtkHBox(false, 5);
        win.add(hbox);
        hbox.packStart(vbox1, false, false, 0);

        GtkFrame frame = new GtkFrame("Normal Label");
        GtkLabel label = new GtkLabel("This is a Normal Label");
        frame.add(label);
        vbox1.packStart(frame, false, false, 0);

        frame = new GtkFrame("Multi-Line Label");
        label = new GtkLabel("This is a Multi-Line Label. \nSecond line\nThird line");
        frame.add(label);
        vbox1.packStart(frame, false, false, 0);

        frame = new GtkFrame("Left Justiied Label");
        label = new GtkLabel("This is a Left-Justified\nMulti-line label.\nThird line");
        label.setJustify(GtkJustification.GTK_JUSTIFY_LEFT);
        frame.add(label);
        vbox1.packStart(frame, false, false, 0);

        frame = new GtkFrame("Right Justified Label");
        label = new GtkLabel("This is a Right-Justified\nMulti-line label\n\nFourth line");
        label.setJustify(GtkJustification.GTK_JUSTIFY_RIGHT);
        frame.add(label);
        vbox1.packStart(frame, false, false, 0);

        GtkVBox vbox2 = new GtkVBox(false, 5);
        hbox.packStart(vbox2, false, false, 0);

        frame = new GtkFrame("Line wrapped label");
        label = new GtkLabel("This is an example of a line-wrapped label.  It should not be taking " +
                             "up the entire             " + // big space to test spacing
                             "width allocated to it, but automatically wraps the words to fit.  " +
                             "The time has come, for all good men, to come to the aid of their party.  " +
                             "The sixth sheik's six sheep's sick.\n" +
                             "     It supports multiple paragraphs correctly, and  correctly  adds " +
                             "many           extra  spaces.  ");
        label.setLineWrap(true);
        frame.add(label);
        vbox2.packStart(frame, false, false, 0);

        frame = new GtkFrame("Filled, wrapped label");
        label = new GtkLabel("This is an example of a line-wrapped, filled label.  It should be taking " +
                             "up the entire              width allocated to it.  Here is a sentence to prove " +
                             "my point.  Here is another sentence.  " +
                             "Here comes the sun, do de do de do \n" +
                             "    This is a new paragraph \n" +
                             "    This is another newer, longer, better paragraph.  It is coming to an end.  " +
                             "unfortunately.");
        label.setJustify(GtkJustification.GTK_JUSTIFY_FILL);
        label.setLineWrap(true);
        frame.add(label);
        vbox2.packStart(frame, false, false, 0);

        frame = new GtkFrame("Underlined label");
        label = new GtkLabel("This label is underlined!\n" +
                             "This one is underlined in quit a funky fashion");
        label.setJustify(GtkJustification.GTK_JUSTIFY_LEFT);
        label.setPattern("_________________________ _ _________ _ _____ _ __ __  ___ ____ _____");
        frame.add(label);
        vbox2.packStart(frame, false, false, 0);

        win.showAll();
    }

    ////////////////////////////////////////////////////////
    // List
    ////////////////////////////////////////////////////////
    public void createList() {
        GtkWindow win = new GtkWindow();
        win.setTitle("list");
        win.setBorderWidth(0);

        GtkVBox vbox = new GtkVBox(false, 0);
        win.add(vbox);

        GtkScrolledWindow scrolled_win = 
            new GtkScrolledWindow(new GtkAdjustment(), new GtkAdjustment());
        scrolled_win.setBorderWidth(5);
        scrolled_win.setUsize(-1, 300);
        vbox.packStart(scrolled_win, true, true, 0);
        scrolled_win.setPolicy(GtkPolicyType.GTK_POLICY_AUTOMATIC,
                               GtkPolicyType.GTK_POLICY_AUTOMATIC);
        
        list = new GtkList();
        list.setSelectionMode(GtkSelectionMode.GTK_SELECTION_EXTENDED);
        scrolled_win.addWithViewport(list);
        //list.setFocusVadjustment(scrolled_win.getVadjustment());
        //list.setFocusHadjustment(scrolled_win.getHadjustment());
        listItemCounter = 1;

        GtkHBox hbox1 = new GtkHBox(true, 5);
        hbox1.setBorderWidth(5);
        vbox.packStart(hbox1, false, true, 0);

        GtkButton button = new GtkButton("Insert Row");
        hbox1.packStart(button, true, true, 0);
        button.signal_connect("clicked", "listAdd", this);

        button = new GtkButton("Clear List");
        hbox1.packStart(button, true, true, 0);
        button.signal_connect("clicked", "listClear", this);
        
        button = new GtkButton("Remove Selection");
        hbox1.packStart(button, true, true, 0);
        button.signal_connect("clicked", "listRemove", this);
        
        GtkHBox hbox2 = new GtkHBox(false, 0);
        vbox.packStart(hbox2, false, true, 0);
        
        GtkHBox hbox3 = new GtkHBox(false, 5);
        hbox3.setBorderWidth(5);
        hbox2.packStart(hbox3, true, false, 0);
        
        GtkHBox hbox4 = new GtkHBox(false, 0);
        vbox.packStart(hbox4, false, true, 0);

        button = new GtkButton("close");
        button.setBorderWidth(10);
        hbox4.packStart(button, true, true, 0);
        button.signal_connect("clicked", "hide", win);

        win.showAll();
    }

    //
    // List Events
    //
    public void listAdd() {
        GtkListItem item = new GtkListItem("Adding item " + listItemCounter++);
        item.show();
        list.add(item);
    }

    public void listClear() {
        list.clearItems(0, -1);
        listItemCounter = 1;
    }

    public void listRemove() {
        System.out.println("Not implmented yet!");
    }
    
    ////////////////////////////////////////////////////////
    // Menus
    ////////////////////////////////////////////////////////
    public GtkMenu createMenu(int items) {

	GtkMenu menu1, menu2;
	GtkMenuItem menuItem;
	GtkCheckMenuItem checkItem;
	int i, j, k;

	menu1 = new GtkMenu();

	for(i = 1; i <= items; i++) {

	    menuItem = new GtkMenuItem("Item" + i);

	    for(j = 1; j <= items; j++) {

		menu2 = new GtkMenu();
		menuItem.setSubmenu(menu2);

		for(k = 1; k <= items; k++) {

		    checkItem = new GtkCheckMenuItem("CheckItem" + k);
		    menu2.append(checkItem);
		    checkItem.show();
		}
	    }

	    menu1.append(menuItem);
	    menuItem.show();
	}

	return menu1;
    }

    public void createMenus() {

	GtkWindow win = new GtkWindow(GtkWindowType.GTK_WINDOW_TOPLEVEL);	
	win.signal_connect("delete_event", this);
	win.setTitle("Menus");
	win.setUsize(200, 100);

	GtkVBox box1 = new GtkVBox(false, 0);
	box1.show();
	win.add(box1);

  	GtkMenuBar menuBar = new GtkMenuBar();
  	menuBar.show();

  	GtkMenu menu1 = new GtkMenu();
  	menu1.show();

  	GtkMenuItem menuItem1 = new GtkMenuItem("Menu 1");
  	menuItem1.show();

  	GtkMenuItem menuItem2 = new GtkMenuItem("Menu 2");
  	menuItem2.show();

  	box1.add(menuBar);
  	menuBar.append(menuItem1);
	menuBar.append(menuItem2);

	menuItem1.setSubmenu(createMenu(5));
	menuItem2.setSubmenu(createMenu(8));

	GtkOptionMenu optionMenu = new GtkOptionMenu();
	optionMenu.setMenu(createMenu(6));
	optionMenu.show();
	box1.add(optionMenu);

	GtkHSeparator separator = new GtkHSeparator();
	box1.packStartDefaults(separator);
	separator.show();
	    
	GtkVBox box2 = new GtkVBox(true, 10);
	box2.setBorderWidth(10);
	box1.packStartDefaults(box2);
	box2.show();
	    
	GtkButton button = new GtkButton("close");
	button.signal_connect("clicked", "hide", win);
	box2.packStartDefaults(button);
	button.show();

	win.show();
	    
    }

    ////////////////////////////////////////////////////////
    // Panes
    ////////////////////////////////////////////////////////
    public void createPanes() {
        GtkWindow win = new GtkWindow();
        win.setTitle("panes");

        GtkVPaned vpaned = new GtkVPaned();
        win.add(vpaned);
        vpaned.setBorderWidth(5);
        vpaned.show();

        GtkHPaned hpaned = new GtkHPaned();
        vpaned.add(hpaned);

        GtkFrame frame = new GtkFrame();
        frame.setShadowType(GtkShadowType.GTK_SHADOW_IN);
        frame.setUsize(60, 60);
        hpaned.add1(frame);
        frame.show();
        
        frame = new GtkFrame();
        frame.setShadowType(GtkShadowType.GTK_SHADOW_IN);
        frame.setUsize(80, 60);
        hpaned.add2(frame);
        frame.show();

        hpaned.show();

        GtkVBox box = new GtkVBox(false, 10);
        box.setBorderWidth(10);
        vpaned.add2(box);
        box.show();
        
        GtkButton button = new GtkButton("close");
        button.signal_connect("clicked", "hide", win);
        box.packStartDefaults(button);
        button.show();
        
        win.show();
    }

    ////////////////////////////////////////////////////////
    // Range Control
    ////////////////////////////////////////////////////////
    public void createRangeControls() {
        GtkWindow win = new GtkWindow();
        win.setTitle("Range Controls");
        win.setBorderWidth (0);

        GtkVBox box1 = new GtkVBox (false, 0);
        win.add(box1);
        box1.show();
                
        GtkVBox box2 = new GtkVBox (false, 10); 
        box2.setBorderWidth(10);
        box1.packStart(box2, true, true, 0);
        box2.show();
        
        GtkAdjustment adjustment = new GtkAdjustment(0, 0, 101, 
                                                      (float)0.1, 1, 1);
        GtkHScale scale = new GtkHScale(adjustment);
        scale.setUsize(150,30);
        scale.setUpdatePolicy (GtkUpdateType.GTK_UPDATE_DELAYED);
        scale.setDigits(1);
        scale.setDrawValue(true);
        box2.packStart(scale, true, true, 0);
        scale.show();
        
        GtkHScrollbar scrollbar = new GtkHScrollbar (adjustment);
        scrollbar.setUpdatePolicy(GtkUpdateType.GTK_UPDATE_CONTINUOUS);
        box2.packStart(scrollbar, true, true, 0);
        scrollbar.show();

        box2 = new GtkVBox (false, 10); 
        box2.setBorderWidth(10);
        box1.packStart(box2, false, true, 0);
        box2.show();
        
        GtkButton button = new GtkButton("close");
        button.signal_connect("clicked", "hide", win);
        box2.packStartDefaults(button);
        //              button.set_flags(CAN_DEFAULT);
        //      button.grabDefault();
        button.show();
        win.show();
        
    }

    ////////////////////////////////////////////////////////
    // Scrolled Window
    ////////////////////////////////////////////////////////
    public void createScrolledWindows() {
        GtkDialog win = new GtkDialog();
        win.setTitle("Scrolled Windows");
        win.setUsize(200, 200);

        GtkScrolledWindow scrolled_window = 
            new GtkScrolledWindow(new GtkAdjustment(), 
                                  new GtkAdjustment());
        scrolled_window.setBorderWidth(10);
        scrolled_window.setPolicy(GtkPolicyType.GTK_POLICY_AUTOMATIC, 
                                  GtkPolicyType.GTK_POLICY_AUTOMATIC);
        ((GtkBox)(win.getvbox())).packStart(scrolled_window);
        scrolled_window.show();

        GtkTable table = new GtkTable(20, 20, true);
        table.setRowSpacings(10);
        table.setColSpacings(10);
        scrolled_window.addWithViewport(table);
        table.show();
        
        for (int i = 0; i < 20; i++)
            for (int j = 0; j < 20; j++) {
                GtkToggleButton button = 
                    new GtkToggleButton("button ("+i+","+j+")");
                table.attach(button, i,i+1, j,j+1, 
                             new GtkAttachOptions(GtkAttachOptions._GTK_EXPAND | 
                                                  GtkAttachOptions._GTK_FILL),
                             new GtkAttachOptions(GtkAttachOptions._GTK_EXPAND | 
                                                  GtkAttachOptions._GTK_FILL
                                                  ));
                button.show();
            }
        GtkButton button = new GtkButton("close");
        button.signal_connect("clicked", "hide", win);
        // action_area has a problem in GtkDialog 
        //((GtkBox)win.getaction_area()).packStart(button, false, false, 10);
        ((GtkBox)win.getvbox()).packStart(button, false, false, 10);
        button.show();
        win.show();
    }

    ////////////////////////////////////////////////////////
    // Toggle Buttons
    ////////////////////////////////////////////////////////
    public void createToggleButtons() {
        GtkWindow win = new GtkWindow();
        win.setTitle("toggle butttons");
        win.setBorderWidth(0);
        GtkVBox box1 = new GtkVBox();
        
        win.add(box1);
        box1.show();
        
        GtkVBox box2 = new GtkVBox(false,10);
        box2.setBorderWidth(10);
        box1.packStartDefaults(box2);
        box2.show();
        for (int i=0; i<4; i++) {
            GtkToggleButton button = new GtkToggleButton("button"+i);
            box2.packStartDefaults(button);
            button.show();
        }
        
        GtkHSeparator separator = new GtkHSeparator();
        box1.packStart(separator, false, false, 0);
        separator.show();
        
        GtkVBox box3 = new GtkVBox(false,10);
        box3.setBorderWidth(10);
        box1.packStart(box3, false, false, 0);
        box3.show();
        
        GtkButton button = new GtkButton("close");
        button.signal_connect("clicked", "hide", win);
        box3.packStartDefaults(button);
        //              button.set_flags(CAN_DEFAULT);
        //      button.grabDefault();
        button.show();
        win.show();
    
    }
    
    ////////////////////////////////////////////////////////
    // Tool Tips
    ////////////////////////////////////////////////////////
    public void createToolTips() {

	GtkWindow win = new GtkWindow();
	win.signal_connect("delete_event", this);
	win.setTitle("Tool Tips");
	win.setBorderWidth(10);
	win.setUsize(200, 100);

	GtkVBox box1 = new GtkVBox();
	box1.show();	

  	GtkMenuBar menuBar = new GtkMenuBar();
  	menuBar.show();

  	GtkMenuItem menuItem = new GtkMenuItem("Menu 1");
  	menuItem.show();

	GtkTooltips toolTips = new GtkTooltips();

  	box1.add(menuBar);
  	menuBar.append(menuItem);
	toolTips.setTip(menuItem, "This is a menu tooltip", "Menu");

	GtkHBox box3 = new GtkHBox();
	box1.packStartDefaults(box3);
	box3.show();

	GtkButton button = new GtkButton("Button");
	button.setBorderWidth(2);
	box3.packStartDefaults(button);
	toolTips.setTip(button, "This is a button with a tooltip.", "Button");
	button.show();

	GtkButton button2 = new GtkButton("Button");
	button2.setBorderWidth(2);
	box3.packStart(button2);
	toolTips.setTip(button2, "This is a button with an extra long tooltip text. This way we can be sure that wrapping works inside of tooltip text. I should ramble a bit more just to make sure though.", "Button");
	button2.show();

	GtkHSeparator separator = new GtkHSeparator();
	box1.packStartDefaults(separator);
	separator.show();
	    
	GtkVBox box2 = new GtkVBox(true, 10);
	box2.setBorderWidth(10);
	box1.packStartDefaults(box2);
	box2.show();
	    
	GtkButton button3 = new GtkButton("close");
	button3.signal_connect("clicked", "hide", win);
	toolTips.setTip(button3, "Use this button to close this window", "Button");
	box2.packStartDefaults(button3);
	button3.show();

	win.add(box1);
	win.show();
	    
    }
    
    ////////////////////////////////////////////////////////
    // Main Window 
    ////////////////////////////////////////////////////////
    public void createMainWindow() {
        Vector v = new Vector();
        // button box
        v.addElement("button box");
        v.addElement("createButtonBox");
        // buttons
        v.addElement("buttons");
        v.addElement("createButtons");
        // check buttons
        v.addElement("check buttons");
        v.addElement("createCheckButtons");
        // clist
        v.addElement("clist");
        v.addElement("createCList");
        // color selection
        v.addElement("color selection");
        v.addElement("createColorSelection");
        // cursor
        v.addElement("cursor");
        v.addElement("null");
        // dialog
        v.addElement("dialog");
        v.addElement("createDialog");
        // dnd
        v.addElement("dnd");
        v.addElement("null");
        // drawing area
        v.addElement("drawing areas");
        v.addElement("null");
        // entry
        v.addElement("entry");
        v.addElement("createEntry");
        // file selection
        v.addElement("file selection");
        v.addElement("createFileSelection");
        // font selection
        v.addElement("font selection");
        v.addElement("createFontSelection");
        // gamma curve
        v.addElement("gamma curve");
        v.addElement("createGammaCurve");
        // handle box
        v.addElement("handle box");
        v.addElement("createHandleBox");
        // labels
        v.addElement("labels");
        v.addElement("createLabels");
        // list
        v.addElement("list");
        v.addElement("createList");
        // menus
        v.addElement("menus");
        v.addElement("createMenus");
        // miscellaneous
        v.addElement("miscellaneous");
        v.addElement("null");
        // notebook
        v.addElement("notebook");
        v.addElement("null");
        // panes
        v.addElement("panes");
        v.addElement("createPanes");
        // pixmap
        v.addElement("pixmap");
        v.addElement("null");
        // preview color
        v.addElement("preview color");
        v.addElement("null");
        // preview gray
        v.addElement("preview gray");
        v.addElement("null");
        // progress bar
        v.addElement("progress bar");
        v.addElement("null");
        // radio buttons
        v.addElement("radio buttons");
        v.addElement("null");
        // range controls
        v.addElement("range controls");
        v.addElement("createRangeControls");
        // reparent
        v.addElement("reparent");
        v.addElement("null");
        // rulers
        v.addElement("rulers");
        v.addElement("null");
        // scrolled windows
        v.addElement("scrolled windows");
        v.addElement("createScrolledWindows");
        // shapes
        v.addElement("shapes");
        v.addElement("null");
        // status bar
        v.addElement("status bar");
        v.addElement("null");
        // test
        v.addElement("test");
        v.addElement("null");
        // test idle
        v.addElement("test idle");
        v.addElement("null");
        // test scrolling
        v.addElement("test scrolling");
        v.addElement("null");
        // test selection
        v.addElement("test selection");
        v.addElement("null");
        // test timeout
        v.addElement("test timeout");
        v.addElement("null");
        // text
        v.addElement("text");
        v.addElement("null");
        // toggle buttons
        v.addElement("toggle buttons");
        v.addElement("createToggleButtons");
        // toolbar
        v.addElement("toolbar");
        v.addElement("null");
        // tooltips
        v.addElement("tooltips");
        v.addElement("createToolTips");

        GtkWindow win = new GtkWindow(GtkWindowType.GTK_WINDOW_TOPLEVEL);
        win.setName("main window");
        win.setUsize(200, 400);
        win.setUposition(20, 20);
        win.signal_connect("destroy", this);
        win.signal_connect("delete_event", this);
        win.setTitle("gtktest");
        GtkVBox box1 = new GtkVBox(false, 0);
        win.add(box1);
        box1.show();
        GtkScrolledWindow scrolledWindow = new GtkScrolledWindow(new GtkAdjustment(),//0,0,0,0,0,0),
        new GtkAdjustment());//0,0,0,0,0,0));
        scrolledWindow.setPolicy(GtkPolicyType.GTK_POLICY_AUTOMATIC, 
                                 GtkPolicyType.GTK_POLICY_AUTOMATIC);
        scrolledWindow.setBorderWidth(10);
        
        box1.packStart(scrolledWindow, true, true, 0);
        
        scrolledWindow.show();
        GtkVBox box2 = new GtkVBox(false, 0); // Constructors without args fail
        box2.setBorderWidth(10);
        scrolledWindow.addWithViewport(box2);
        box2.show();
        //box1.packStart(box2, false, false, 1);
        for (int i = 0; i < v.size(); i++) {
            String key = (String)v.elementAt(i);
            GtkButton button = new GtkButton(key);
            String value = (String) v.elementAt(++i); 
            if (value.equals("null"))
                button.setSensitive(false);
            else
                button.signal_connect("clicked", (String)value, this);
            box2.packStart(button, true, true, 0);
            button.show();
        }
        GtkHSeparator separator = new GtkHSeparator();
        box1.packStart(separator, false, true, 0);
        separator.show();
        GtkVBox box3 = new GtkVBox(false, 10);
        box3.setBorderWidth(10);
        box1.packStart(box3, false, true, 0);
        box3.show();
        GtkButton button = new GtkButton("close");
        button.signal_connect("clicked", this);
        //button.setFlags(Gtk.GTK_CAN_DEFAULT);
        box3.packStart(button, true, true, 0);
        //      button.grabDefault();
        button.show();
        win.show();
    }

  
    public TestGTK()
    {
        createMainWindow();
        //      createToggleButtons();
        //createButtons();
        
    }     

   
    public static void main(String[] args)
    {
        Gtk.init(0,0);
        TestGTK test = new TestGTK();
        Gtk.main();
    }
}




